{-# LANGUAGE InstanceSigs #-}
module Language.Java.Classfile.Magic (Magic(..)) where
import Data.Word (Word32)
import Language.Java.Classfile.Extractable (Extractable, extract, expectConstant)
import Language.Java.Classfile.Extract (Extract)
import Data.Hex (Hex (Hex))

data Magic = Magic (Hex Word32)
  deriving Show

instance Extractable Magic where
  extract :: Extract Magic
  extract = Magic . Hex <$> expectConstant 0xCAFEBABE

